# config for hostname: {{ name }}
user nobody; # a directive in the 'main' context

events {
    # configuration of connection processing
}

http {
    # Configuration specific to HTTP and affecting all virtual servers  

    #
    # Backend Services 
    #
    {% if services is defined and services | length > 0 %}
    {%- for service in services %}
    {%- if service.backend is defined and "HTTP" in service.type -%}
    # {{ service.type | lower }} service backed 
    upstream {{ service.backend.name }} {

    }
    {% endif -%} 
    {% endfor %}
    {% endif %}

    server {
        # configuration of HTTP virtual server 1       
        location / {
            {% for service in services -%}
            {% if service.type == 'HTTP' and service.backend is defined %}
            proxy_pass http://{{ service.backend.name }}
            {% endif -%}
            {% endfor -%}
        }

    } 


}


stream {
    # Configuration specific to TCP/UDP and affecting all virtual servers

    #
    # Backend Services 
    #
    {% if services is defined and services | length > 0 %}
    {%- for service in services %}
    {%- if service.backend is defined and "HTTP" not in service.type -%}
    # {{ service.type | lower }} service backed 
    upstream {{ service.backend.name }} {

    }
    {% endif -%} 
    {% endfor %}
    {% endif %}

    {% if services is defined and services | length > 0 %}
    {% for service in services %}
    {% if "HTTP" not in service.type  %}
    # {{ service.name }} virtual server
    server {
        {% for listener in service.listeners -%}
        {% if listener.protocol == "UDP" -%}
        listen {{ listener.port }} udp;
        {% else -%}
        listen {{ listener.port }};
        {% endif -%}
        {% endfor -%}

        {% if service.backend is defined -%}
        proxy_pass {{ service.backend.name }};
        proxy_bind $remote_addr transparent;
        {% endif %}
    }
    {% endif -%}
    {% endfor -%}
    {% endif -%}


    
    
}